/*
 *  Utility to make a rom image for Ericsson XXX VHF mobile.
 *
 *  Sun Mar  1 20:03:55 EET 1998, juha, OH5NXO
 *
 *  Output is the raw image.
 */

#include <stdio.h>
#include <string.h>

static int
	location;       /* of 128 byte space */

static unsigned
	IF   = 21600,
	Step =    25,
	Mod  =    64;

static unsigned char
	rom[8192];

static void
addword(b)
{
	rom[location++] = 0x0F & (b >>  0);
	rom[location++] = 0x0F & (b >>  4);
	rom[location++] = 0x0F & (b >>  8);
	rom[location++] = 0x0F & (b >> 12);
}


static void
addchan(freq, off)
	unsigned freq, off;
{
	unsigned N, A;

	N = ((freq - IF) / Step) / Mod;
	A = ((freq - IF) / Step) % Mod;

	addword((N << 8) | A);
	addword(0x03C0);

	N = ((freq + off) / Step) / Mod;
	A = ((freq + off) / Step) % Mod;

	addword((N << 8) | A);
	addword(0x03C0);
}

main(argc, argv)
	char **argv;
{
	int i;

	memset(rom, 0xFF, sizeof(rom));

#if 0
	if (argc < 2) {
		fprintf(stderr, "\
Usage: mkprom freq ...\n\
");
		exit(2);
	}
	for (i = 1; i < argc; ++i) {
		addchan(atoi(argv[i]), 0);
	}
#else
	for (i = 145625; i < 145800; i += 25) {
		addchan(i, -600);
	}
	for (i = 145200; i < 145600; i += 25) {
		addchan(i, 0);
	}
	addchan(145600, -600);

	addchan(144800, 0);
	addchan(144825, 0);
	addchan(144850, 0);
	addchan(144875, 0);

	addchan(144000, 0);
	addchan(146000, 0);

#endif

#if 1
	write(1, rom, sizeof(rom));
#else
	for (i = 0; i < location; ) {
		int j;

		for (j = 0; j < 8; ++i, ++j) {
			putchar("0123456789ABCDEF"[(rom[i]) >> 4]);
			putchar("0123456789ABCDEF"[(rom[i]) & 15]);
		}
		putchar('\n');
	}
#endif

	exit(0);
}

