
vip slips one channel with # if scanner on

screw keeps scanning

indicators always visible

3rd digit: Small L during keyguard, t during xmit
4th digit: blank, degree or small o wrt duplex offset

other (overseas) duplex regions

75ms burst period, 1 second of silence first.



!----------------------------------------------------------------------
!
!  Kyodo KG109 aka H40 aka Autonet-10 UHF HT
!
!  0.7  970520 First workable version.
!  0.9  970529 AUDIO follows BUSY. Beeps. Memories.
!  1.0  970630 ... uh... Some changes.
!  1.1  970701 430..499  coverage
!  1.2  970701 Genouts
!  1.3a 970718 Modem rx testing, reducing squelch pops
!  1.3b 970719 keyguard unaffected by screw. long # for current memory.
!  1.3c 970719 Simpler MSK-calling.
!  1.4  970905 ID no more hardcoded.
!  2.0  980214 DTMF, some other changes. 430..450 TX.
!
!  Juha, OH5NXO
!
#define VERSION "@(#)KG109 2.0 980214 PROM"
#define VERSMAJ 2
#define VERSMIN 0

!----------------------------------------------------------------------
!
!  General notes
!
!  Some connectors have reversed numbering on different schematics.
!  Monitor-button also lights up the smaller LCD...
!  Backlight of the larger LCD is sourced from a 4099...
!

!----------------------------------------------------------------------
!
!  E2PROM layout
!
!  First e2prom is memories 0..63, 16 bits per memory, LSbits are channel #
!  Second e2prom is offsets per memory
!
!  Third e2prom contains misc stuff.
!
!  ee_xxx takes address as one byte 0..191 and selects e2prom
!  according to two MSbits.
!

MEM_CHMSK  = 0x07
MEM_EXIST  = 0x80
MEM_SCAN   = 0x40
MEM_RPTR   = 0x20

MEM_SCANNABLE = 0xC000	! Or above

EE_MEMORY_BLOCK   =   0	! In first e2prom
EE_OFFSET_BLOCK   =  64	! In second e2prom
EE_MISC_BLOCK     = 128	! In third e2prom

!
!  Variable 'memory' number has bits b7 and b6 set when "memory is hidden",
!  to be able to return to the same memory after "vfo mode".
!
!----------------------------------------------------------------------
!
!  Generate HZ timer interrupt.
!  Reload OCR1 as quickly as reasonable, in the interrupt, to minimize skew ?
!
!  4.032 MHz Xtal
!  1.008 MHz E Clock
!
HZ      = 100
PROCCLK = 1008000
SYSTICK = (PROCCLK / HZ)

!----------------------------------------------------------------------
!
!  Ftx = Fvco
!  Frx = Fvco + 21.6 MHz
!
!  1st IF 21.6 MHz
!
!  20000 kHz coverage with 12.5 kHz steps gives 1600 channels
!  11 bits required to store.

#define f2div(f)  ((f) * 10 / 125)
#define f2chan(f) (f2div(f) - TXBASE)

TXBASE    = f2div(430000)
RXBASE    = TXBASE - f2div(21600)
NCHANNELS = f2chan(450000) - f2chan(430000)

! RPTROFF   = f2div(1600)

NOCHAN    = 0x07FF

!  Synth TC9181 from Toshiba.
!  Data in LSb first.
!  Prescaler 64/65.
!  Reference TCXO 6 MHz.
!  Two last (highest, MSb) bits control where the data goes.
!
!  0b11 XX                    General purpose output pins. 1mA sink/source.
!
!  0b00 00                    Lock detector "gain" setting.
!
!  0b10 10 RRRRRRRRRRRR       Reference divider, "channel spacing"
!              12             Middle two bits have to be 10 on KG109.
!
!  0b01 NNNNNNNNNNN 0 AAAAAA  Counter, "12.5 channel"
!         11            6
!
!  NNNNNNNNNNAAAAAA is straight Fvco / 12.5, nice.
!  Use R of 480 for 12.5
!
!  Shift from LSb, first 6 bits (A), then one bit of zeropad,
!  then rest of divisor (11 bits, N) and finally 0b01. Strobe it.
!


!----------------------------------------------------------------------
!
!  Control register, IC11 4099
!  Notice how address bus A5,A6,A7 is reversed to A2,A1,A0 in decoder.
!  IC11 data is DB7.
!

ONEBIT      = 0x80
ZEROBIT     = 0x00

MDM_TXOFF   = 0x4000 ! 0      FX419
CLOCK       = 0x4020 ! 1      PCF2100, synth, e2prom clock
AUDIO       = 0x4040 ! 2 CN3P
RXON        = 0x4060 ! 3 CN3P aka PWRSAVE, easier to think with this name...
LCD_LIGHT   = 0x4080 ! 4 CN5  aka SPARE O/P
DATA        = 0x40A0 ! 5      PCF2100, synth, e2prom write
DLEN        = 0x40C0 ! 6      PCF2100
SYN_STROBE  = 0x40E0 ! 7 CN3P

!
!  Pin assignments
!
!  P6 generic pins 0, 4 and 5 inputs, P6DDR 0xCE
!
!  P60         in  RESET input (just logical...)
!  P61         out e2prom1enb
!  P62         out e2prom2enb
!  P63         out e2prom3enb
!  P64         in  voltage comparator 1
!  P65         in  voltage comparator 2
!  P66         out modulation off
!  P67         out PTT_OUT
!
!  P2 generic pins all inputs except SIDETONE and SCAN, P2DDR 0x44,
!  serial tx implied output pin,
!  SCL i/o as necessary, DDR changed.
!  TXPOWER (originally SCAN) is used to select transmit power.
!
!  P20 (Tin)   in  RXSYNC from modem, generate Input Capture Interrupt
!  P21 (Tout1) i/o SCL to PCD3312 and KEYPAD, to Molex-2
!  P22 (SCLK)  out SCAN, only unused pin, TXPOWER selection.
!  P23 (Rx)    in  RS-232 IN
!  P24 (Tx)    inx RS-232 OUT
!  P25 (Tout2) in  UP
!  P26 (Tout3) out SIDETONE, Toggles From Timer 2, occasionally
!  P27 (TCLK)  in  DOWN
!
!  P5 generic pin 4 output, P5DDR 0x10 or 0x11 when iicing.
!
!  P50 (/IRQ1) i/o SDA to PCD3312 and KEYPAD, e2prom read
!  P51 (/IRQ2) in  TXSYNC from modem, could get /IRQ2, but we poll instead
!  P52 (MR)    in  DCD from modem
!  P53 (/HALT) in  RXDATA from modem
!  P54 (/IS)   out TXDATA to modem
!  P55 (/OS)   in  BUSY, "0" when squelch open.
!  P56         in  PTT-1 and PTT-2
!  P57         in  PTT-1 and CALL
!

!----------------------------------------------------------------------
!
!  Make the IIC bit-fiddling somewhat more readable
!  Portpin is either output and pulled low, or input. There is pullup.
!  So setting the DDR is all we need to do iic.
!  Code is not good, generic or std iic, beware.
!

#define SCL_BIT    bit @PORT2, $ P2SCL
#define SDA_BIT    bit @PORT5, $ P5SDA

#define SCL_PULL   and @PORT2, $~P2SCL ; jsr iic_delay
#define SDA_PULL   and @PORT5, $~P5SDA ; jsr iic_delay

#define SCL_HIGH   push a; ld a, $0x44; st a, @P2DDR; pop a; jsr iic_delay
#define SCL_LOW    push a; ld a, $0x46; st a, @P2DDR; pop a; jsr iic_delay

#define SDA_HIGH   push a; ld a, $0x10; st a, @P5DDR; pop a; jsr iic_delay
#define SDA_LOW    push a; ld a, $0x11; st a, @P5DDR; pop a; jsr iic_delay

!----------------------------------------------------------------------
!
!  Beginning of RAM is masked by internal registers and storage.
!  There can be either 2 or 8 kB RAM.
!

#define BYTE   : .rs 1
#define WORD   : .rs 2
#define BUF(n) : .rs (n)

	.data
	.org 0x0000

	ASSERT(. == 0x00)

P1DDR	BYTE	! 00 WO                                 FE
P2DDR	BYTE	! 01 WO                                 00
PORT1	BYTE	! 02 RW                                 ??
PORT2	BYTE	! 03 RW                                 ??

	P2SCL      = 0x02	! PCF3312, PCF8574 and PCF8576
	P2TXPOWER  = 0x04	! RF.P. Control
	P2UP       = 0x20	! Signals from ...
	P2SIDETONE = 0x40	! Local tones.
	P2DOWN     = 0x80	! ... "VFO".

P3DDR	BYTE	! 04 WO                                 FE
P4DDR	BYTE	! 05 WO                                 00
PORT3	BYTE	! 06 RW                                 ??
PORT4	BYTE	! 07 RW                                 ??

TCSR1	BYTE	! 08 RW Timer Control/Status Register 1 00

	ICF   = 0x80
	OCF1  = 0x40
	TOF   = 0x20
	EICI  = 0x10
	EOCI1 = 0x08
	ETOI  = 0x04
	IEDG  = 0x02
	OLVL1 = 0x01

FRC		WORD	! 09 RW Free Running Counter            0000
OCR1	WORD	! 0B RW Output Compare Register 1       FFFF
ICR		WORD	! 0D RO Input Capture Register          0000
TCSR2	BYTE	! 0F RW Timer Control/Status Register 2 10

	OCF2   = 0x20
	EOICI2 = 0x08
	OLVL2  = 0x04
	OE2    = 0x02
	OE1    = 0x01

RMCR	BYTE	! 10 RW Rate/Mode Control Register      C0

	SS0 = 0x01
	SS1 = 0x02
	CC0 = 0x04
	CC1 = 0x08
	CC2 = 0x10
	SS2 = 0x20

TRCSR1	BYTE	! 11 RW Tx/Rx Control/Status Register 1 20
RDR		BYTE	! 12 RO Receive Data Register           00
TDR		BYTE	! 13 WO Transmit Data Register          ??

RP5CR	BYTE	! 14 RW RAM/PORT5 Control Register      F8 or 78

	STBY_PWR  = 0x80
	RAME      = 0x40
	STBY_FLAG = 0x20
	IRQ2E     = 0x02
	IRQ1E     = 0x01

PORT5	BYTE	! 15 RW                                 ??

	P5SDA    = 0x01	! PCF3312, PCF8574 and PCF8576, data from e2prom
	P5TXSYNC = 0x02	! Modem tx clock
	P5DCD    = 0x04	! Modem dcd
	P5RXDATA = 0x08	! Modem rx data
	P5TXDATA = 0x10	! Modem tx data
	P5BUSY   = 0x20	! Input from squelch, "0" when open.
	P5PTT1   = 0x40	! Both PTT buttons activate this
	P5CALL   = 0x80	! PTT-1 and CALL

P6DDR	BYTE	! 16 WO                                 00
PORT6	BYTE	! 17 RW                                 ??

	P6MONI  = 0x01	! aka DEF MUTE or RESET
	P6EE0   = 0x02
	P6EE1   = 0x04
	P6EE2   = 0x08
	P6BATT1 = 0x10	! "1" for above level
	P6BATT2 = 0x20	! "1" for above level
	P6MIC   = 0x40	! /MODULATION_OFF
	P6TXON  = 0x80	! PTT_OUT

PORT7	BYTE	! 18 RW                                 ??

OCR2	WORD	! 19 RW Output Compare Register 2       FFFF
TCSR3	BYTE	! 1B RW Timer Control/Status Register 3 20

	CMF  = 0x80 ! Counter Match Flag, read-only
	ECMI = 0x40 ! Enable Counter Match Interrupt
	T2E  = 0x10 ! Timer 2 Enable
	TOS1 = 0x08 ! Timer Output Select
	TOS0 = 0x04
	CKS1 = 0x02 ! Input Clock Select
	CKS0 = 0x01

TCONR	BYTE	! 1C WO Time Constant Register          FF
T2CNT	BYTE	! 1D RW Timer 2 Up Counter              00
TRCSR2	BYTE	! 1E RW Tx/Rx Control/Status Register 2 28

TSTREG	BYTE	! 1F -- KEEP OFF !!!

P5DDR	BYTE	! 20 WO                                 00
P6CSR	BYTE	! 21 RW PORT 6 Control/Status Register  07

	ASSERT(. == 0x22)

!
!  Hole to external RAM
!
	.org 0x0028

!
!  Internal RAM
!  RAM changes external again at 0x0140
!
	.org 0x0040

_bss:

memflag		BYTE	! Almost unnecessary
monidown	BYTE

tps			BYTE	! Hz counter
lbolt		BYTE	! Seconds
txflag		BYTE	! If any bit NZ, tx is on

signal		BYTE	! 00 01 03 07 0F 1F 3F 7F FF signal "duration"

flags		BYTE

	LOW_BATT = 0x01

rxon_timer		WORD
rxoff_timer		WORD

dingdongsw		BYTE
sidetone_timer	WORD
keyscan_timer	BYTE
key_guard		BYTE
keydown_timer	BYTE
scan_timer		WORD
spack_timer		WORD

ee_update_reqd	BYTE	! Slow lcd/e2prom update from screw
small_update_reqd	BYTE	! Slow lcd/e2prom update from screw

keybits		BYTE	! Keypad scanner bits
key			BYTE	! Translated
keytime		BYTE	! Seconds key was held down

digval		WORD
digidx		BYTE
digbuf		BUF(12)

scan_state	WORD	! scanner pc
scan_mode	BYTE	! Which scanning algorithm, 0 not active

	SCAN_BAND = 1
	SCAN_MEM  = 2
	SCAN_VFOS = 3

	IND_BATT = 0x1
	IND_BUSY = 0x2
	IND_TX   = 0x4
	IND_SCAN = 0x8

indicators	BYTE	! BUSY BATT TX SCAN in upper LCD
smalldigits	WORD	! two digits in upper LCD

mdm_state	WORD
bitsync		WORD
bitcount	BYTE

!
!  64 16bit memories, cached here writethrough.
! This is image of e2prom
!

	.align 2
e2prom_image:

misc_block:

channel		WORD	! # of channels above base. "currfreq"
B_channel	WORD
C_channel	WORD

memory_misc:
memory		BYTE
miscbits	BYTE	! Hi/Lo b2, general outputs b1 b0


mycall		BUF(8)		! Currently only 5 used.

rptrfix			WORD	! Added during TX for duplex op.
rptroff			WORD	! Dynamic
rptroff_default	WORD	! Default for no memories

	.align 1

misc_block_words = (. - misc_block) / 2

	.align 7

memories	BUF(64 * 2)

offsets		BUF(64 * 2)

e2prom_image_end:

feedback_tens	BYTE
feedback_ones	BYTE

	.align 2
dpydigits	BUF(20)	! 160 bits of big LCD, Word aligned for even/odd mapping


reject_idx	BYTE		! for overwriting oldest

reject_0	WORD
reject_1	WORD
reject_2	WORD
reject_3	WORD
reject_4	WORD
reject_5	WORD
reject_6	WORD
reject_7	WORD
reject_8	WORD
reject_9	WORD		! Has to be 10.

vip_idx		BYTE

vip_0		WORD
vip_1		WORD
vip_2		WORD
vip_3		WORD
vip_4		WORD		! Has to be 5.

vip_tmp		WORD

VIP_IS_MEM = 0x8000		! Not channel but a memory

packet		BUF(8)
packet_good	BUF(6)
packet_rdy	BYTE

outpacket	BUF(8)

!
!  Stack from end of RAM (just 2kB for now, there might be 8kB SRAM)
!
	.org 0x07FF
stack:

_end:

!----------------------------------------------------------------------
!
!  EPROM is in last 16 kB
!
	.text
	!.org 0xC000		! This for 16 kB
	.org 0xE000		! This for 8 kB

	.byte 0

version: .asciz VERSION

!   0D      11      2D      31
! 09  0C  15  10  29  2C  35  30   .....
!   08      14      28      34
! 05  04  19  18  25  24  39  38
!   01      1D      21      3D
!  even    odd     even    odd     .....

segtbl_odd:!0123456789ABCDEF
	.word 0b1100010011000100 ! 0
	.word 0b1000000010000000 ! 1
	.word 0b1100100001000100 ! 2
	.word 0b1100100010000100 ! 3
	.word 0b1000110010000000 ! 4
	.word 0b0100110010000100 ! 5
	.word 0b0100110011000100 ! 6
	.word 0b1100000010000000 ! 7
	.word 0b1100110011000100 ! 8
	.word 0b1100110010000100 ! 9
	.word 0b1100110011000000 ! A
	.word 0b0000110011000100 ! b
	.word 0b0100010001000100 ! C
	.word 0b1000100011000100 ! d
	.word 0b0100110001000100 ! E
	.word 0b0100110001000000 ! F
	.word 0b0000000000000000 ! ' '
	.word 0b0000100001000000 ! 'r'
	.word 0b0000010001000100 ! 'L'
	.word 0b1100110001000000 ! 'P'
	.word 0b0000110001000100 ! 't'
	.word 0b0000110000000000 ! '`-'
	       !0123456789ABCDEF
!   0D      11      2D      31
! 09  0C  15  10  29  2C  35  30   .....
!   08      14      28      34
! 05  04  19  18  25  24  39  38
!   01      1D      21      3D
!  even    odd     even    odd     .....
segtbl_even:!123456789ABCDEF
	.word 0b0100110001001100 ! 0
	.word 0b0000100000001000 ! 1
	.word 0b0100010010001100 ! 2
	.word 0b0100100010001100 ! 3
	.word 0b0000100011001000 ! 4
	.word 0b0100100011000100 ! 5
	.word 0b0100110011000100 ! 6
	.word 0b0000100000001100 ! 7
	.word 0b0100110011001100 ! 8
	.word 0b0100100011001100 ! 9
	.word 0b0000110011001100 ! A
	.word 0b0100110011000000 ! b
	.word 0b0100010001000100 ! C
	.word 0b0100110010001000 ! d
	.word 0b0100010011000100 ! E
	.word 0b0000010011000100 ! F
	.word 0b0000000000000000 ! ' '
	.word 0b0000010010000000 ! 'r'
	.word 0b0100010001000000 ! 'L'
	.word 0b0000010011001100 ! 'P'
	.word 0b0100010011000000 ! 't'
	.word 0b0000000011000000 ! '`-'
	       !0123456789ABCDEF
!   0D      11      2D      31
! 09  0C  15  10  29  2C  35  30   .....
!   08      14      28      34
! 05  04  19  18  25  24  39  38
!   01      1D      21      3D
!  even    odd     even    odd     .....

	LCD_blank = 0x10
	LCD_r     = 0x11
	LCD_L     = 0x12
	LCD_P     = 0x13
	LCD_t     = 0x14

	LCD_rpos  = 0x15
	LCD_rneg  = LCD_r

!----------------------------------------------------------------------
!
!	                 FEDCBA9876543210
	SMALL_Er     = 0b0001001101000111
	SMALL_bF     = 0b0011101101100101
	SMALL_L      = 0b0000001100000001
	SMALL_H      = 0b0000111100000100

!
!  BUSY=b1        b1       bD
!               b9  bA   b5  b6     b3 and b7 unused, (???)
!                 b2       bE
!  BATT=b0      b8  bB   b4  b7
!                 b0       bC
!
!   TX=b2   SCAN=b3
!

segtbl_small:
	!       FEDCBA9876543210
	.word 0b0011000011110000	! 0  Right digit of upper LCD
	.word 0b0000111100000011	! 0  Left digit of upper LCD
	.word 0b0000000011000000	! 1
	.word 0b0000110000000000	! 1
	.word 0b0111000001010000	! 2
	.word 0b0000010100000111	! 2
	.word 0b0111000011000000	! 3
	.word 0b0000110000000111	! 3
	.word 0b0100000011100000	! 4
	.word 0b0000111000000100	! 4
	.word 0b0111000010100000	! 5
	.word 0b0000101000000111	! 5
	.word 0b0111000010110000	! 6
	.word 0b0000101100000111	! 6
	.word 0b0010000011000000	! 7
	.word 0b0000110000000010	! 7
	.word 0b0111000011110000	! 8
	.word 0b0000111100000111	! 8
	.word 0b0111000011100000	! 9
	.word 0b0000111000000111	! 9
	.word 0b0110000011110000	! A
	.word 0b0000111100000110	! A
	.word 0b0011000010110000	! b
	.word 0b0000101100000101	! b
	.word 0b0011000000110000	! C
	.word 0b0000001100000011	! C
	.word 0b0101000011010000	! d
	.word 0b0000110100000101	! d
	.word 0b0111000000110000	! E
	.word 0b0000001100000111	! E
	.word 0b0110000000110000	! F
	.word 0b0000001100000110	! F
	.word 0b0000000000000000	! F
	.word 0b0000000000000000	! F
	!       FEDCBA9876543210

	SMALL_blank = 0x10

!  BUSY=b1        b1       bD
!               b9  bA   b5  b6     b3 and b7 unused, (???)
!                 b2       bE
!  BATT=b0      b8  bB   b4  b7
!                 b0       bC

	nop
	nop
	nop		! make sure following code aligns ok, for naive dis6303.

!----------------------------------------------------------------------
!
!  Initialize synthesizer for 12.5 kHz spacing
!
init_synth:

	ld d, $ 480					! 6MHz / 12.5 kHz
	ld x, $12
	jsr sendit

	ld b, $ 0b1010
	ld x, $4
	jsr sendit
	jsr strobe_synth			! Reference divider...

	ld b, $ 0b0000
	ld x, $4
	jsr sendit
	jsr strobe_synth			! Lock detector gain....

	rts

genout_synth:

	ld b, @miscbits
	and b, $3
	or b, $ 0b1100
	ld x, $4
	jsr sendit
	jsr strobe_synth			! General outputs....

	rts

!----------------------------------------------------------------------
!
!  Generate load pulse for synthesizer
!
strobe_synth:
	ld a, $ONEBIT
	st a, *SYN_STROBE
	ld a, $ZEROBIT
	st a, *SYN_STROBE
	rts

!----------------------------------------------------------------------
!
!  d has channel as NP+A
!  64/65 allows us to skip the division.
!
! 432000 34560 0103400 34560 0x8700 ^@ 1000'0111'0000'0000'
! 438000 35040 0104340 35040 0x88e0  . 1000'1000'1110'0000'
! x channels with 12.5 kHz spacing
!

assert_channel:

	ld x, @channel

	cmp x, $(NCHANNELS)
	bc 1f					! At 430000 .. 449987, ok
	bz 2f					! At 450000, go to 430000
	ld x, $(NCHANNELS - 1)	! Below 430000, go to 449987
	st x, @channel
	br 1f
2:
	ld x, $0
	st x, @channel
1:

	ld d, $0
	st d, @rptrfix
	st d, @rptroff

	ld x, @channel
	cmp x, $ f2chan(434600)
	bc 1f
	cmp x, $ f2chan(435000)
	bnc 1f
	ld d, @rptroff_default
	st d, @rptrfix			! Duplex area
	st d, @rptroff
	rts
1:
	rts


wake_upd_synth:
	bsr assert_channel

wake_upd_synth_no_rptr_default:
	ld a, $ZEROBIT
	st a, *AUDIO

	bit @txflag, $0xFF
	bnz 1f
	jmp rx_synth
1:
	jmp tx_synth

rx_synth:

	ld x, $500
	st x, @rxon_timer		! 5 seconds active listening after change.
	ld a, $ONEBIT
	st a, *RXON

rx_synth_no_wake:

	ld d, $ RXBASE			! Divisor for lowest channel
	add d, @channel			! Now D has the right divisor for simplex
	br 9f

tx_synth:

	ld d, $ TXBASE			! Divisor for lowest channel
	add d, @channel			! Now D has the right divisor for simplex
	add d, @rptrfix
9:

	ld x, $6
	jsr sendit		! A5..A0

	jsr zerobit		! A6 always zero

	ld x, $10
	jsr sendit		! N9..N0

	jsr zerobit		! N10 always zero

	ld b, $ 0b01	! Direct them to divider
	ld x, $2
	jsr sendit

	jsr strobe_synth
	rts

!----------------------------------------------------------------------
!
!  Big (lower) LCD
!

shut_big_lcd:

	jsr iic_start

	!  Slave address
	!  0 1 1 1 0 0 SA0 R/W
	ld a, $ 0b01110000
	jsr iic_sbyte

	!  MODE SET
	!  C 1 0 LP E B M1..M0
	!  0 1 0 1  0 1 0 0
	ld a, $ 0b01010100
	jsr iic_sbyte

	jsr iic_stop

	rts

init_big_lcd:

	jsr iic_start

	!  Slave address
	!  0 1 1 1 0 0 SA0 R/W
	ld a, $ 0b01110000
	jsr iic_sbyte

	!  MODE SET
	!  C 1 0 LP E B M1..M0
	!  1 1 0 1  1 1 0 0
	ld a, $ 0b11011100
	jsr iic_sbyte

	!  LOAD DATA POINTER
	!  C 0 P5..P0
	!  1 0 0 0 0 0 0 0
	ld a, $ 0b10000000
	jsr iic_sbyte

	!  DEVICE SELECT
	!  C 1 1 0 0 A2..A0
	!  1 1 1 0 0 0 0 0
	ld a, $ 0b11100000
	jsr iic_sbyte

	!  BANK SELECT
	!  C 1 1 1 1 0 I O
	!  1 1 1 1 1 0 0 0
	ld a, $ 0b11111000
	jsr iic_sbyte

	!  BLINK
	!  C 1 1 1 0 A BF1..BF0
	!  0 1 1 1 0 0 0 0
	ld a, $ 0b01111000
	jsr iic_sbyte

	jsr iic_stop

	rts

update_big_lcd:

	jsr iic_start

	!  Slave address
	!  0 1 1 1 0 0 SA0 R/W
	ld a, $ 0b01110000
	jsr iic_sbyte

	!  LOAD DATA POINTER
	!  C 0 P5..P0
	!  1 0 0 0 0 0 0 0
	ld a, $ 0b10000000
	jsr iic_sbyte

	!  DEVICE SELECT
	!  C 1 1 0 0 A2..A0
	!  0 1 1 0 0 0 0 0
	ld a, $ 0b01100000
	jsr iic_sbyte

	ld x, $dpydigits
1:
	ld a, *x
	inc x
	jsr iic_sbyte
	cmp x, $(dpydigits + SIZE(dpydigits))
	bnz 1b

	jsr iic_stop

	rts

!  PCF3312 Code in A

iic_dtmf:

	push a

	jsr iic_start

	!  Slave address
	!         010010AW
	ld a, $ 0b01001000
	jsr iic_sbyte

	pop a
	jsr iic_sbyte

	jsr iic_stop

	rts

!----------------------------------------------------------------------
!
!  Remember the LCD might be in powersaving state...
!  This is too much in any case.
!
iic_delay:
	nop
	nop
	nop
	nop
	nop

	rts

iic_start:

	SDA_HIGH
	SCL_HIGH				! Set them free

	SDA_PULL				! output state low, when DDR set
	SCL_PULL
1:
	SCL_BIT
	bz 1b					! Wait iic idle

	SDA_LOW					! START condition
	SCL_LOW					! both kept low

	rts

iic_stop:

	SDA_LOW					!
	SCL_HIGH				! Let them go for
1:
	SCL_BIT
	bz 1b

	SDA_HIGH				! STOP condition

	rts

iic_sbyte:

	bsr iic_sbit
	bsr iic_sbit
	bsr iic_sbit
	bsr iic_sbit

	bsr iic_sbit
	bsr iic_sbit
	bsr iic_sbit
	bsr iic_sbit

	SDA_HIGH		! for acknowledge from receiver
	bsr iic_dobit

	rts

iic_sbit:
	rlc a
	bnc iic_zerobit
	br  iic_onebit

iic_zerobit:

	SDA_LOW
	br iic_dobit

iic_onebit:

	SDA_HIGH
	br iic_dobit

iic_dobit:

	SCL_HIGH
1:
	SCL_BIT
	bz 1b		! wait to go up

	SCL_LOW

	rts

iic_rbyte:

	SDA_HIGH

	bsr iic_rbit
	bsr iic_rbit
	bsr iic_rbit
	bsr iic_rbit

	bsr iic_rbit
	bsr iic_rbit
	bsr iic_rbit
	bsr iic_rbit

	rts				! Now acknowledge, we only read a byte at a time...

iic_rbit:

	SCL_HIGH
1:
	SCL_BIT
	bz 1b		! wait to go up

	asl a
	SDA_BIT
	bz 1f
	inc a
1:
	SCL_LOW

	rts

!----------------------------------------------------------------------
!
!  Keypad
!
write_keypad:
	jsr iic_start

	ld a, $ 0b01000000
	jsr iic_sbyte

	ld a, @keybits
	or a, $ 0x0F
	jsr iic_sbyte
	jsr iic_stop
	rts

read_keypad:
	jsr iic_start

	ld a, $ 0b01000001
	jsr iic_sbyte

	jsr iic_rbyte
	jsr iic_stop

	xor a, $0xF
	and a, $0xF
	rts

scan_keypad:
	ld b, $0
	ld a, $0x70
	st a, @keybits
	bsr write_keypad
	bsr read_keypad
	bnz 1f
	ld b, $4
	ld a, $0xB0
	st a, @keybits
	bsr write_keypad
	bsr read_keypad
	bnz 1f
	ld b, $8
	ld a, $0xD0
	st a, @keybits
	bsr write_keypad
	bsr read_keypad
	bnz 1f
	ld b, $12
	ld a, $0xE0
	st a, @keybits
	bsr write_keypad
	bsr read_keypad
	bnz 1f
	ld b, $-1
	rts
1:
	rrc a; bc 1f; inc b
	rrc a; bc 1f; inc b
	rrc a; bc 1f; inc b
1:
	rts

check_keypad:
	bsr read_keypad
	bz 9f
	wai
	bsr scan_keypad
	clr *keybits
	jsr write_keypad
	cmp b, $-1
	bz 9f
	bit @PORT5, $P5PTT1
	bz 1f					! if no PTT
	jsr do_dtmf
	br 9f
1:
	st b, @key
	bit @key_guard, $1
	bz 1f					! No guard, blip
	cmp b, $12
	bnz 2f					! Guard, but not *, no blip
	bit @PORT6, $ P6MONI
	bz 2f					! Guard, *, but no moni, no blip
1:
	jsr keyblip
2:
	clr b
	st b, @keydown_timer
	st b, @keytime
	ld a, $1
	st a, @keydown_timer
1:
	cmp b, @keytime
	bz 2f
	ld b, @keytime
	bit @key_guard, $1
	bnz 2f					! Guard on, no "long press" blops
	jsr keyblop
2:
	jsr read_keypad
	bnz 1b
	clr a
	st a, @keydown_timer
	jsr handle_key
9:
	ld b, $20			! 1/5 sec to next check
	ld a, @key_guard
	bz 1f
		ld b, $100		! one sec if keyguard active
1:
	st b, @keyscan_timer
	rts

keytbl:  .byte    1,    2,    3, 0x0A,    4,    5,    6, 0x0B,    7,    8,    9, 0x0C,  '*',    0,  '#', 0x0D

dtmftbl: .byte 0x11, 0x12, 0x13, 0x1A, 0x14, 0x15, 0x16, 0x1B, 0x17, 0x18, 0x19, 0x1C, 0x1E, 0x10, 0x1F, 0x3F

DTMF_OFF = 0x01		! No tone, 3-state pin, oscillator off

! keycode in B

do_dtmf:
	and @PORT6, $~P6MIC		! XXX reactivate mic from timeout...

	ld x, $dtmftbl
	add x, b
	ld a, *x
	jsr iic_dtmf
1:
	jsr read_keypad
	bnz 1b

	ld a, $ DTMF_OFF
	jsr iic_dtmf
	rts

handle_key:
	ld b, @key
	ld x, $keytbl
	add x, b
	ld a, *x
	st a, @key

	bit @key_guard, $1
	bz 1f
	cmp a, $'*'
	bnz 2f
	bit @PORT6, $P6MONI
	bz 2f
	jsr keyblop
	clr *key_guard
	br 9f
2:
	rts					! Only * will do
1:
	cmp a, $'*'
	bnz 1f
		bit @PORT6, $P6MONI
		bz 2f
			xor @key_guard, $1
			jsr keyblop
			br 9f
	2:
		jmp send_digit_packet
1:
	cmp a, $0xA
	bnz 1f

	jsr do_A_key
	br 9f
1:
	jsr scan_end

	ld a, @key

	cmp a, $10
	bnc 1f
	jmp handle_digit
1:
	cmp a, $'#'
	bnz 1f
	jmp execute
1:
	cmp a, $0xD
	bnz 1f

	jsr rptr_mode_set
	br 9f
1:
	ld x, $0
	st x, @digval
	st x, @digidx	! Zeroes also first of digbuf...

	cmp a, $0xC
	bnz 1f

	jsr do_C_channel
	br 9f
1:
	cmp a, $0xB
	bnz 1f

	clr *vip_idx
1:
9:
	jsr draw_freq

	rts

send_digit_packet:

	ld b, @digidx
	bz 9f

	ld a, $0xC0
	or a, *(mycall + 0)
	st a, *(outpacket + 0)

	ld a, *(mycall + 1)
	asl a; asl a; asl a; asl a
	or a, *(mycall + 2)
	st a, *(outpacket + 1)

	ld a, *(mycall + 3)
	asl a; asl a; asl a; asl a
	or a, *(mycall + 4)
	st a, *(outpacket + 2)

	ld b, $0
	ld x, $(outpacket + 3)
2:
	push x
	ld a, $0xFF
	cmp b, @digidx
	bz 1f
	ld x, $digbuf
	add x, b
	inc b
	ld a, *x
	asl a; asl a; asl a; asl a
	or a, $0xF
	cmp b, @digidx
	bz 1f
	inc b
	and a, $0xF0
	or a, x[1]
1:
	pop x
	st a, *x
	inc x
	cmp x, $outpacket + SIZE(outpacket) - 2
	bnz 2b

	jsr append_packet_crc
9:
	jsr tx_on_no_mic

	ld x, $110			! Delay in case receiver powersaving
	st x, @spack_timer
1:
	ld x, @spack_timer
	bnz 1b

	jsr send_packet
	jsr send_packet

	jsr rx_on

	ld x, $0
	st x, @digval
	st x, @digidx	! Zeroes also first of digbuf...

	jmp draw_freq

packet_header:
	.word 0b1010101010101010
	.word 0b1010101010101010
	.word 0b1010101010101010
	.word 0b1010101010101010
	.word 0b1010101010101010
	.word 0b1100010011010111		! SYNC word
packet_header_end:

packet_trailer:
	.word 0b0000000000000000		! Trailer

send_packet:

	ld a, $ZEROBIT
	st a, *MDM_TXOFF		! Enable modem xmit

	ld x, $ packet_header
1:
	jsr send_packet_word
	cmp x, $ packet_header_end
	bnz 1b

	ld x, $ outpacket
1:
	jsr send_packet_word
	cmp x, $ outpacket + SIZE(outpacket)
	bnz 1b

	ld x, $ packet_trailer
	jsr send_packet_word

	ld a, $ONEBIT
	st a, *MDM_TXOFF		! Disable

	rts

send_packet_word:
	ld d, *x
	inc x
	inc x
	bsr send_abit; bsr send_abit; bsr send_abit; bsr send_abit
	bsr send_abit; bsr send_abit; bsr send_abit; bsr send_abit
	bsr send_abit; bsr send_abit; bsr send_abit; bsr send_abit
	bsr send_abit; bsr send_abit; bsr send_abit; bsr send_abit
	rts

send_abit:
3:
	bit @PORT5, $ P5TXSYNC
	bnz 3b					! Wait dropping sync
	asl d
	bnc 1f
	or @PORT5, $ P5TXDATA
	br 2f
1:
	and @PORT5, $~P5TXDATA
2:
	bit @PORT5, $ P5TXSYNC
	bz 2b					! Wait rising sync

	rts

do_A_key:
	ld d, $0
	st d, @scan_timer		! Continue quickly if running

	ld a, @keytime
	bz 9f
	cmp a, $1
	bnz 3f
	ld x, $ reject_0		! blip blop : reject this
	ld b, *reject_idx
	inc b
	cmp b, $10
	bc 1f
	clr b
1:
	st b, *reject_idx
	asl b
	add x, b
	ld d, @channel
	st d, *x				! Overwrite oldest reject
	rts
3:
	ld d, $ NOCHAN			! blip blop blop : unreject all
	st d, *reject_0
	st d, *reject_1
	st d, *reject_2
	st d, *reject_3
	st d, *reject_4
	st d, *reject_5
	st d, *reject_6
	st d, *reject_7
	st d, *reject_8
	st d, *reject_9
	rts
9:
	clr *vip_idx		! List replacement position.
	ld x, $0
	st x, @digval
	st x, @digidx

	ld x, $scan_start
	st x, @scan_state

	ld a, $SCAN_BAND
	bit @memory, $0x80
	bnz 1f
	ld a, $SCAN_VFOS
	bit @memory, $0x40
	bnz 1f
	ld a, $SCAN_MEM
1:
	st a, @scan_mode

	rts

do_C_channel:
	ld a, @keytime
	bz 1f
	ld x, @channel
	st x, @C_channel
	ld a, @memory
	or a, $64
	st a, @memory		! C programmed, now "in C channel"
	jsr store_state
	rts
1:
	!
	!  0...63   in memory
	!  0b01xxx  in C
	!  0b1xxxx  other
	!
	!  First on "VFO", then "C", then "memories", then "VFO" again
	!
	ld b, @memory
	cmp b, $64
	bnc 1f
	or b, $128			! to "VFO" from memory
	st b, @memory
	ld x, @B_channel
	st x, @channel		! Restore VFO frequency
	jsr wake_upd_synth
	jsr store_state
	rts
1:
	cmp b, $128
	bnc 1f
	jsr set_b_memory	! to "memories" from C
	jsr store_state
	rts
1:
	and b, $~128		! to C from VFO
	or b, $64
	st b, @memory
	ld x, @channel
	st x, @B_channel	! Remember VFO frequency
	ld d, @C_channel
	st d, @channel		! Set C frequency
	jsr wake_upd_synth
	jsr store_state
	rts

save_b_memory:
	and b, $63
	st b, @memory
	ld x, $memories
	asl b
	add x, b
	ld d, @channel
	and a, $ MEM_CHMSK
	or a, $ (MEM_EXIST | MEM_SCAN)

	br 9f

save_b_memory_noscan:
	and b, $63
	st b, @memory
	ld x, $memories
	asl b
	add x, b
	ld d, @channel
	and a, $ MEM_CHMSK
	or a, $ (MEM_EXIST)
9:
	push x
	ld x, @rptrfix
	bz 2f
	or a, $ MEM_RPTR
2:
	pop x
	br 9f

clear_b_memory:
	and b, $63
	st b, @memory
	ld x, $memories
	asl b
	add x, b
	ld d, *x
	and a, $~(MEM_EXIST | MEM_SCAN)
9:
	st d, *x
	st a, @memflag
	xch x, d
	ld b, @memory
	jsr memory_write

	rts

set_b_memory:
	push a
	and b, $63
	st b, @memory
	ld x, $memories
	asl b
	add x, b
	ld d, *x				! memories[memory]
	st a, @memflag
	and a, $MEM_CHMSK
	st d, @channel			! channel updated

	bit @memflag, $ MEM_RPTR
	bz 2f
	ld b, $ SIZE(memories)
	add x, b				! skip over to offsets[memory]
	ld d, *x
	st d, @rptrfix
	st d, @rptroff
	br 1f
2:
	ld d, $0
	st d, @rptrfix
	ld d, @rptroff_default
	st d, @rptroff
1:
	jsr wake_upd_synth_no_rptr_default
	pop a
	bit @memflag, $ MEM_EXIST
	rts

get_b_memory:
	push b
	and b, $63
	ld x, $memories
	asl b
	add x, b
	ld x, *x
	pop b
	rts

rptr_mode_set:				! Roll the repeater mode

	ld a, @keytime
	bz 9f
	ld b, @digidx
	bnz 8f
							! Just long D, flip duplex, keep channel
	ld d, $ 0
	sub d, @rptroff
	st d, @rptroff
	st d, @rptrfix
	jsr store_state
	rts
8:							! 1600 long D

	ld d, @digval
	jsr clearbuf
	ld x, $ 0
1:
	inc x
	inc x
	sub d, $ 25
	bz 1f
	bnc 1b
	dec x
1:
	xch d, x

	st d, @rptroff		! Long D with numner sets the offset
	bit @keytime, $ 0xFE
	bnz 1f				! Long long D sets it positivef
	ld d, $0
	sub d, @rptroff
	st d, @rptroff		! Just tik tok, negative
1:
	st d, @rptroff_default

	ld x, @rptrfix
	bz 1f
	st d, @rptrfix		! Update active value also
1:
	jsr store_state
	rts
9:
	jsr clearbuf

	ld x, @rptrfix			! Simplex ?
	bnz 2f
	ld x, @rptroff
	bnz 1f
	ld x, @rptroff_default
	st x, @rptroff			! Set it now
1:
	st x, @rptrfix			! simplex to duplex
	jsr wake_upd_synth_no_rptr_default
	rts
2:
	cmp x, @rptroff			! Duplex ?
	bnz 2f
	ld d, @channel
	add d, @rptrfix
	st d, @channel			! Duplex to reverse
	ld d, $ 0
	sub d, @rptrfix
	st d, @rptrfix
	jsr wake_upd_synth_no_rptr_default
	rts
2:
	ld d, @channel			! reverse to simplex
	add d, @rptrfix
	st d, @channel
	ld x, $ 0
	st x, @rptrfix
	jsr wake_upd_synth_no_rptr_default
	rts

handle_digit:

	ld a, @digidx
	bnz 1f					! b if already some digits
	ld b, @keytime
	bz 1f					! b if short press
	clr a					! MSB of memory number
	ld b, @key				! long press
	jsr set_b_memory
	jsr save_vip_channel	! One single long digit equals 0# to 9#
	jsr store_state
	jmp ex_done
1:
	cmp a, $SIZE(digbuf)
	bc 1f
	rts
1:
	ld x, $digbuf
	ld b, @digidx
	add x, b
	inc b
	st b, @digidx

	ld a, @key
	st a, *x
	ld b, a
	ld a, $0

	add d, @digval ; bc 1f ! 1
	add d, @digval ; bc 1f ! 2
	add d, @digval ; bc 1f ! 3
	add d, @digval ; bc 1f ! 4
	add d, @digval ; bc 1f ! 5
	add d, @digval ; bc 1f ! 6
	add d, @digval ; bc 1f ! 7
	add d, @digval ; bc 1f ! 8
	add d, @digval ; bc 1f ! 9
	add d, @digval ; bc 1f ! 10
	br 2f
1:
	ld d, $0xFFFF
2:
	st d, @digval

	jsr draw_freq
9:
	rts

ex_setup:

	ld x, $digbuf

	ld a, X[0]
	asl a
	asl a
	asl a
	asl a
	or a, X[1]

	cmp a, $0x01			! 01nnnnn  MYCALL
	bnz 1f
	ld d, X[2]
	st d, *(mycall + 0)
	ld d, X[4]
	st d, *(mycall + 2)
	ld d, X[6]
	st d, *(mycall + 4)
	ld d, X[8]
	st d, *(mycall + 6)
	br 9f
1:
9:
	jsr store_state

	br ex_done

ex_done:
	ld d, $0
	st d, @digval
	st b, @digidx

	jsr draw_freq

	rts


execute:

	ld b, @digidx
	bz ex_hash			! Just #

	cmp b, $7
	bc 1f
	jmp ex_setup		! cc nnnnn #
1:
	cmp b, $3
	bc 1f
	jmp ex_freq			! nnn #
1:
	ld d, @digval		! a is clear, only nn decimal
	cmp b, $64
	bc 1f
	jmp ex_command		! 64# ... 99#
1:
	jmp ex_memory		! 0# ... 63#

ex_hash:

	ld b, @keytime
	bz 9f
	! Single long #, use current memory to program
	clr a
	xch d, x
	ld b, @memory
	and b, $63			! Long #, program memory, but keep offset info
	cmp x, $1
	bnz 1f
	jsr save_b_memory
	jmp ex_done
1:
	cmp x, $2
	bnz 1f
	jsr save_b_memory_noscan
	jmp ex_done
1:
	jsr clear_b_memory
	jmp ex_done

vip_recall:
	clr *vip_idx

9:

	ld x, $ vip_0
	ld b, *vip_idx
	asl b
	add x, b			! *x is next vip ch/mem
	ld b, *vip_idx
	inc b
	cmp b, $5
	bc 1f
	clr b
1:
	st b, *vip_idx		! idx++ % 5
	ld x, *x
	cmp x, $ VIP_IS_MEM
	bc 1f
	xch d, x			! it was a memory
	jsr set_b_memory
	jsr store_state
	jmp ex_done
1:
	st x, @channel		! it was a channel
	jsr leave_memory
	jsr wake_upd_synth
1:
	jmp ex_done

ex_freq:
	ld b, @digidx
	clr a
	xch d, x
	ld d, $0			! 4xxxxx
	cmp x, $6
	bhi 1b			! > 6 digits
	bc 2f
			! 6 digits, digval has overflowed, redo

	ld x, $digbuf
	ld a, *x
	inc x
	cmp a, $4
	bz 1f
	jmp ex_done			! has to be 4xxyyy
1:
	ld d, $0
1:
	st d, @digval
	add d, @digval; add d, @digval; add d, @digval;
	add d, @digval; add d, @digval; add d, @digval;
	add d, @digval; add d, @digval; add d, @digval;
	add b, *x
	adc a, $0
	inc x
	cmp x, $(digbuf + 6)
	bnz 1b
	br 3f
2:
	cmp x, $5
	bz 2f
	add d, $30000		! < 5 digits, 43xxxx
	cmp x, $4
	bz 2f
	add d, $3000		! < 4 digits, 433xxx
2:
	add d, @digval		! Add given number
3:
	jsr freq2chan
	xch d, x
	cmp x, $NCHANNELS
	bnc 1f

	jsr leave_memory
	st x, @channel
	jsr save_vip_channel
	jsr wake_upd_synth
	jsr store_state
1:
	jmp ex_done

ex_memory:
	ld a, @keytime
	bnz 1f
	ld d, @digval
	jsr set_b_memory
	jsr save_vip_channel
	jsr store_state
	jmp ex_done
1:
	cmp a, $1
	bnz 2f
	ld d, @digval		! Long #, program memory
	jsr save_b_memory
	jsr rewrite_curmem_offset
	jmp ex_done
2:
	cmp a, $2
	bnz 3f
	ld d, @digval
	jsr save_b_memory_noscan
	jsr rewrite_curmem_offset
	jmp ex_done
3:
	ld d, @digval
	jsr clear_b_memory
	jsr rewrite_curmem_offset
	jmp ex_done

ex_command:
	ld d, @digval

	cmp b, $90
	bnz 1f
	and @PORT2, $~P2TXPOWER		! Low power
	and @miscbits, $~4
	and @(smalldigits + 0), $~(SMALL_H / 256)
	and @(smalldigits + 1), $~(SMALL_H & 255)
	or @(smalldigits + 0), $ (SMALL_L / 256)
	or @(smalldigits + 1), $ (SMALL_L & 255)
	jsr update_small_lcd
	jsr store_state
	jmp ex_done
1:
	cmp b, $99
	bnz 1f
	or @PORT2, $ P2TXPOWER		! Hi power
	or @miscbits, $ 4
	and @(smalldigits + 0), $~(SMALL_L / 256)
	and @(smalldigits + 1), $~(SMALL_L & 255)
	or @(smalldigits + 0), $ (SMALL_H / 256)
	or @(smalldigits + 1), $ (SMALL_H & 255)
	jsr update_small_lcd
	jsr store_state
	jmp ex_done
1:
	cmp b, $80
	bnz 1f
	and @miscbits, $~1
	and @(smalldigits + 1), $~0x20
	br ex_genout
1:
	cmp b, $81
	bnz 1f
	or @miscbits, $ 1
	or @(smalldigits + 1), $ 0x20
	br ex_genout
1:
	cmp b, $70
	bnz 1f
	and @miscbits, $~2
	and @(smalldigits + 1), $~0x40
	br ex_genout
1:
	cmp b, $71
	bnz 1f
	or @miscbits, $ 2
	or @(smalldigits + 1), $ 0x40
	br ex_genout
1:
	cmp b, $66
	bnz 1f
	ld d, $0
	st d, @digval
	st b, @digidx
	jsr draw_packet
	rts
1:
	cmp b, $73
	bnz 1f
	ld d, $0
	st d, @digval
	st b, @digidx
	jsr draw_version
	rts
1:
	jmp ex_done

ex_genout:
	jsr update_small_lcd
	jsr store_state
	jsr genout_synth
	jmp ex_done

!
!  D has frequency in binary number, (4)30000..(4)49987
!  D returns channel number
!
freq2chan:

	sub d, $30000
	bnc 1f
	ld d, $NCHANNELS
	rts
1:
	ld x, $-1
1:
	inc x
	sub d, $25
	bnc 1b

	add d, $25
	xch x, d
	asl d
	cmp x, $6
	bc 1f
	inc b
1:
	rts

!----------------------------------------------------------------------
!
!  Update small (upper) LCD
!
update_small_lcd:

	ld a, $ZEROBIT
	st a, *DLEN
	st a, *DATA

	ld a, $ONEBIT
	st a, *DLEN

	jsr zerobit		! leading zerobit

	ld b, @indicators
	ld x, $4
	jsr sendit		! BUSY BATT TX SCAN

	ld b, @(smalldigits + 0)
	ld x, $8
	jsr sendit		! First group of twodigit channel

	ld d, $0xFF
	ld x, $8
	jsr sendit		! Padding

	jsr onebit		! This was group 1

	ld a, $ZEROBIT
	st a, *DLEN
	st a, *DATA

	jsr clockit		! load pulse for group 1

	ld a, $ONEBIT
	st a, *DLEN

	jsr zerobit		! leading zerobit

	ld b, $0xF
	ld x, $4
	jsr sendit		! Padding

	ld b, @(smalldigits + 1)
	ld x, $8
	jsr sendit		! Second group of twodigit channel

	ld d, $0xFF
	ld x, $8
	jsr sendit		! Padding

	jsr zerobit		! This was group 0

	ld a, $ZEROBIT
	st a, *DLEN
	st a, *DATA

	jsr clockit		! load pulse for group 0

	rts

clockit:
	push a
	ld a, $ONEBIT
	st a, *CLOCK
	ld a, $ZEROBIT
	st a, *CLOCK
	pop a
	rts

!----------------------------------------------------------------------
!
!  x lowest bits from d into synth or small lcd, LSb first, max 16 bits.
!
sendit:
1:
	lsr d			! LSb into carry
	push a			! save d, carry kept
	rrc a			! carry into bit7
	st a, *DATA		! bit to dataline
	ld a, $ONEBIT
	st a, *CLOCK	! raise and ...
	ld a, $ZEROBIT
	st a, *CLOCK	! lower clock
	pop a
	dec x
	bnz 1b
	rts

zerobit:
	push a			! keep all
	ld a, $ZEROBIT
	br 1f

onebit:
	push a			! keep all
	ld a, $ONEBIT
1:
	st a, *DATA		! bit to dataline
	ld a, $ONEBIT
	st a, *CLOCK	! raise and ...
	ld a, $ZEROBIT
	st a, *CLOCK	! lower clock
	pop a
	rts

!----------------------------------------------------------------------
!
!  RXSYNC from modem generated Input Capture for Timer 1
!
_ici:
	ld a, @TCSR1	! read and ...
	ld d, @ICR		! discard these, rearm ICI.

	ld x, @mdm_state
	bz mdm_hunt
	jmp *x

mdm_hunt:
	bit @PORT5, $ P5DCD		! Carrier ?
	bnz 1f
	ld x, $0
	st x, @bitsync
	st x, @mdm_state
	rti
1:
	ld d, @bitsync
	asl d
	bit @PORT5, $ P5RXDATA	! Which bit is coming ?
	bz 1f
	inc b
1:
	st d, @bitsync
	cmp a, $0xAA
	bnz 1f
	cmp b, $0xAA
	bnz 1f
	ld x, $mdm_sync
	st x, @mdm_state
1:
	rti

mdm_sync:
	bit @PORT5, $ P5DCD		! Carrier ?
	bnz 1f
	ld x, $0
	st x, @bitsync
	st x, @mdm_state
	rti
1:
	ld d, @bitsync
	asl d
	bit @PORT5, $ P5RXDATA	! Which bit is coming ?
	bz 1f
	inc b
1:
	st d, @bitsync
	cmp a, $0b11000100
	bnz 1f
	cmp b, $0b11010111		! SYNC word
	bnz 1f
	ld x, $mdm_data
	st x, @mdm_state
	ld b, $ (8 * 8)
	st b, @bitcount
1:
	rti

mdm_data:
	clc
	bit @PORT5, $ P5RXDATA	! Which bit is coming ?
	bz 1f
	sec
1:
	rlc *(packet + 7)
	rlc *(packet + 6)
	rlc *(packet + 5)
	rlc *(packet + 4)
	rlc *(packet + 3)
	rlc *(packet + 2)
	rlc *(packet + 1)
	rlc *(packet + 0)

	dec *bitcount
	bnz 1f
	ld x, $0
	st x, @bitsync
	st x, @mdm_state
	ld a, *packet_rdy
	bnz 1f
	jsr check_packet
1:
	rti

!----------------------------------------------------------------------
!
!  timer tick from Output Compare 1
!
_oci:
	ld a, @TCSR1	! discard this for rearming OCI1.
	ld d, @OCR1
	add d, $SYSTICK
	st d, @OCR1		! rearm and set match after next SYSTICKs. Slight skew ?

	!
	!  And now systick() things.
	!

	ld a, @tps
	inc a
	st a, @tps
	cmp a, $ HZ
	bnz 9f
	clr *tps
	inc *lbolt
	!
	!  One second has elapsed
	!  Unused fact.
	!
9:

	!
	!  Squelch slow open/close
	!
	ld a, @signal
	bit @PORT5, $P5BUSY
	bz 1f
	clr a					! Real squelch closed
	br 2f
1:							! Real squelch open
	asl a
	or a, $1
2:
	st a, @signal

	!
	!  Pending update from screw ?
	!
	ld a, @ee_update_reqd
	bz 9f
	cmp a, $150
	inc a			! Carry kept
	bc 1f
	ld a, $0xFF
1:
	st a, @ee_update_reqd
9:

	ld a, @small_update_reqd
	bz 9f
	cmp a, $100
	inc a			! Carry kept
	bc 1f
	ld a, $0xFF
1:
	st a, @small_update_reqd
9:

	!
	!  Downcount some timers
	!
	ld a, @keyscan_timer
	bz 9f
	dec a
	st a, @keyscan_timer
9:
	ld x, @scan_timer
	bz 9f
	dec x
	st x, @scan_timer
9:
	ld x, @spack_timer
	bz 9f
	dec x
	st x, @spack_timer
9:
	!
	!  Increment key downtime timer
	!
	ld a, @keydown_timer
	bz 9f
	inc a
	cmp a, $HZ
	bnz 1f
	inc *keytime
	ld a, $1
1:
	st a, @keydown_timer
9:

	!
	!  Powersaving timers, watch out races with mainline.
	!
	bit @txflag, $0xFF
	bnz 9f				! Skip during transmission

	ld x, @rxon_timer
	bnz 1f
	ld x, @rxoff_timer	! Powersaving.
	dec x
	st x, @rxoff_timer
	bnz 9f
	ld a, $ONEBIT		! powersave period ended.
	st a, *RXON
	ld x, $10
	st x, @rxon_timer	! listen for 200 ms
	br 9f
1:
	dec x				! Listening
	st x, @rxon_timer
	bnz 9f
	ld a, $ZEROBIT
	st a, *AUDIO
	st a, *RXON			! shut down rx after 5 seconds idle
	ld x, $90
	st x, @rxoff_timer	! powersave for 800 ms.
9:

	rti

!----------------------------------------------------------------------
!
!  Timer 2 Counter Match Interrupt.
!  Not used for anything currently.
!  SIDETONE local tone in P26 is automatic, if ever enabled...
!
_cmi:
	and @TCSR3, $~CMF	! clear CMF, rearm CMI.

	!
	!  Downcount SIDETONE timer (note length of tone depends on frequency)
	!
	ld x, @sidetone_timer
	bz 1f
	dec x
	st x, @sidetone_timer
	bnz 1f
	ld b, @dingdongsw
	bz 2f
	dec b
	st b, @dingdongsw
	ld x, $43
	ld a, $(PROCCLK / 8 / (2 * 1200)) - 1
	bit b, $1
	bnz 3f
	ld x, $50
	ld a, $(PROCCLK / 8 / (2 * 1400)) - 1
3:
	st a, @TCONR
	st x, @sidetone_timer	! again for this many halfpulses
	rti
2:
	and @TCSR3, $~T2E	! Stop timer 2
	and @TCSR3, $~CMF	! Clear CMF, paranoia ? Not, needed...
1:
	rti

!----------------------------------------------------------------------
!
!  Kinda Dr Allcome.
!
_unk:
_irq1:
_irq2:
_sio:
_toi:
_swi:
_nmi:
_trap:
	jmp _start

!----------------------------------------------------------------------
!
poweroff:

	sei						! "Do Not Disturb"

	!
	!  Get as quiet as possible
	!
	clr b

	st b, @PORT6			! No TXON

	st b, *LCD_LIGHT
	st b, *AUDIO			! No light and no rx
	st b, *RXON

	clr a

	st d, @smalldigits
	ld b, $ IND_BATT
	st b, @indicators

	ld sp, $stack			! Paranoid

	jsr shut_big_lcd		! No DC state for LCDs,
	jsr update_small_lcd	! just leave BATT in the smaller one.
	jsr pompompom

	ld x, $0
1:
	nop
	nop
	dec x
	bnz 1b

	and @TCSR3, $~T2E	! Stop the noise

	br .

!----------------------------------------------------------------------
!
!   Reset vector
!
_start:

	sei
	ld sp, $stack

	!
	!  Tx OFF immediately
	!

	ld a, $0xCE
	st a, @P6DDR
	ld a, $0x00
	st a, @PORT6

	!
	!  /IRQ1 and /IRQ2 disabled.
	!  "Memory ready" MRE and AMRE disabled.
	!  /HALT disabled
	!  Internal RAM enabled
	!  Not entering stand-by state.
	!  Valid-ram flag set.
	!
	ld a, $(STBY_PWR | RAME | STBY_FLAG)
	st a, @RP5CR

	!
	!  Only output now in PORT5 is TXDATA, iic will change this later.
	!
	ld a, $0x10
	st a, @P5DDR
	st a, @PORT5

	!
	!  Configure the Serial Communication Interface here...
	!  Some synchronous modes prevent using P22 (originally named SCAN)
	!  as output pin... Should have RRRRRTFM...
	!  8bit asynchronous, internal clock, P22 not used
	!  SS1 creates baudrate near 984. Available on PC...
	!  Configure more later.

	ld a, $(CC0| SS1)
	st a, @RMCR

	!
	!  TXPOWER (SCAN) and SIDETONE here
	!
	ld a, $0x44
	st a, @P2DDR
	ld a, $ 0		! Low power and alarm pin low
	st a, @PORT2

	!
	!  Initialize the output-latch
	!
	ld a, $ZEROBIT

	st a, *SYN_STROBE
	st a, *LCD_LIGHT
	st a, *CLOCK
	st a, *DATA
	st a, *DLEN
	st a, *RXON				! RX Powersave on (== rx off) and
	st a, *AUDIO			! audio off until all set.

	ld a, $ONEBIT

	st a, *MDM_TXOFF

	!
	!  Try resetting interrupt logic by reading the statuses
	!  of all timer registers and clearing CMF.
	!
	ld a, @TCSR1
	ld d, @ICR
	ld a, @TCSR2
	ld d, @OCR1
	ld a, @TCSR3
	and @TCSR3, $~CMF

	!
	!  Timer tick and modem rxsync come from Timer 1
	!  Tick from Output Compare 1 and RXSYNC from Input Capture.
	!  IEDG is "0", as data from modem is valid on trailing RXSYNC.
	!
	ld a, $SYSTICK
	st a, @OCR1

	ld a, $(EOCI1 | EICI)
	st a, @TCSR1

	!
	!  Timer 2 is used for sidetone (and txbeeps).
	!  Input is (FRC of Timer 1) / 8.
	!  Output Select is used to toggle SIDETONE, for local (and tx) tones.
	!  Counter is stopped when not generating keyclicks or alarms or ...
	!  Use or @TCSR3, $T2E to start, and and @TCSR3, $~T2E to stop.
	!  Interrupt is enabled, and will run after timer enabled.
	!
	!  4032000 Hz CLK
	!  1008000 Hz E CLK
	!
	!   126000 Hz Timer 2 input for /= 8 (CKSx)
	!	  1750 Hz from constant 72
	!	  3500 Hz from constant 36  (this for beep)
	!      494 Hz from constant 255

	ld a, $(PROCCLK / 8 / (2 * 1750)) - 1
	st a, @TCONR

	ld a, $(CKS0 | ECMI | TOS0)
	st a, @TCSR3

	!
	!  Wait and clear zero data.
	!

	ld x, $ 0
1:
	dec x
	bnz 1b

	ld x, $_bss
	clr a
1:
	st a, *x
	inc x
	cmp x, $_end
	bnz 1b

	!-----------------------------------------------------------------
	!
	!  If switch-off or battery removed, wait.
	!

	ld b, $ IND_BATT
	st b, @indicators
	ld d, $ SMALL_Er
	st d, @smalldigits

	jsr update_small_lcd

	cli						! 100Hz
1:
	jsr keyblip

	bit @PORT5, $P5PTT1
	bnz 1b					! Scream until ptt released
1:
	wai
	bit @PORT6, $P6BATT2
	bz 1b					! Sleep here if battery empty

	ld a, $ONEBIT
	st a, *RXON
	ld x, $500
	st x, @rxon_timer		! 5 seconds active listening after powerup

	!
	!  Restore state from e2prom.
	!
	jsr load_e2prom_image

	jsr init_big_lcd

	ld a, $100
	st a, @keyscan_timer

	jsr write_keypad

	ld d, $ SMALL_L
	bit @miscbits, $ 4
	bz 1f
	or @PORT2, $ P2TXPOWER	! Set Hi power
	ld d, $ SMALL_H
1:
	bit @miscbits, $ 1
	bz 1f
	or b, $ 0x20
1:
	bit @miscbits, $ 2
	bz 1f
	or b, $ 0x40
1:
	st d, @smalldigits

	jsr update_small_lcd

	ld b, @memory
	cmp b, $64
	bnc 1f
	jsr set_b_memory
	ld d, $ VIP_IS_MEM
	ld b, @memory
	br 2f
1:
	ld d, @channel
2:
	st d, *vip_0
	st d, *vip_1
	st d, *vip_2
	st d, *vip_3
	st d, *vip_4

	!
	!  Configure synthesizer.
	!
	jsr init_synth
	jsr genout_synth
	jsr rx_on

	ld a, $ DTMF_OFF
	jsr iic_dtmf

	ld a, $ONEBIT
	st a, *AUDIO

	jsr draw_freq

	ld d, $ NOCHAN
	st d, *reject_0
	st d, *reject_1
	st d, *reject_2
	st d, *reject_3
	st d, *reject_4
	st d, *reject_5
	st d, *reject_6
	st d, *reject_7			! Clear volatile rejects
	st d, *reject_8			! Clear volatile rejects
	st d, *reject_9			! Clear volatile rejects

	jmp main				! Enter mainloop

!---------------------------------------------------------------------

load_e2prom_image:

	ld b, $ EE_MEMORY_BLOCK
	ld x, $ memories
	bsr load_e2prom

	ld b, $ EE_OFFSET_BLOCK
	ld x, $ offsets
	bsr load_e2prom

	ld b, $ EE_MISC_BLOCK
	ld x, $ misc_block
	bsr load_e2prom
	rts

load_e2prom:

1:
	push b
	push x
	jsr memory_read
	xch d, x
	pop x
	st d, *x
	inc x
	inc x
	pop b
	inc b
	bit b, $ 63
	bnz 1b

	rts

!
!  Note WEN/WDS only for one e2prom. Change if necessary.
!
store_state:

	ld b, $EE_MISC_BLOCK
	bsr ee_WEN
1:
	push b
	sub b, $EE_MISC_BLOCK
	asl b					! word address to byte offset in ram
	ld x, $misc_block
	add x, b
	pop b
	ld x, *x
	bsr ee_WRITE
	inc b
	cmp b, $(EE_MISC_BLOCK + misc_block_words)
	bc 1b

	ld b, $EE_MISC_BLOCK
	bsr ee_WDS
	rts

!---------------------------------------------------------------------
!
!  64 16bit words per e2prom.
!  "global 8bit word-address" EEAAAAAA is
!                             e2prom number
!                               address there

!
!  Write data in X to (global) e2prom address B
!
memory_write:

	bsr ee_WEN
	bsr ee_WRITE
	bsr ee_WDS

	rts

!---------------------------------------------------------------------
!
!  Read e2prom data to X from address B
!
memory_read:

	clr a
	asl d
	asl d			! e2prom # to A
	lsr b
	lsr b			! 00AAAAAA to B

	or b, $0b10000000		! READ
	bsr ee_prologue	! select e2prom and send 0b10AAAAAA

	ld b, $16
2:
	ld a, $ONEBIT
	st a, *CLOCK

	xch d, x
	asl d					! Assume bit 0
	SDA_BIT
	bz 1f
	inc b					! Set LSb
1:
	xch d, x

	ld a, $ZEROBIT
	st a, *CLOCK
	dec b
	bnz 2b

	bsr ee_epilogue

	rts

!----------------------------------------------------------------------

ee_WRITE:
	push b
	clr a
	asl d
	asl d
	push a				! Remember e2prom #
	lsr b
	lsr b
	or b, $0b01000000	! WRITE
	jsr ee_prologue
	push x
	pop b				! High
	jsr ee_sendbyte
	pop b				! Low byte
	jsr ee_sendbyte
	bsr ee_epilogue

	pop a				! The saved e2prom #
	bsr ee_select
1:
	SDA_BIT
	bz 1b				! Busywait programming time.
	bsr ee_epilogue

	pop b
	rts

ee_WEN:
	push b
	clr a
	asl d
	asl d					! e2prom # to A

	ld b, $0b00110000		! 0b0011 WEN for selected e2prom
	bsr ee_prologue
	bsr ee_epilogue

	pop b
	rts

ee_WDS:
	push b
	clr a
	asl d
	asl d

	ld b, $0b00000000		! 0b0000 WDS for selected e2prom
	bsr ee_prologue
	bsr ee_epilogue

	pop b
	rts

!
!  Idle state after ee activity. A destroyed.
!
ee_epilogue:

	and @PORT6, $~(P6EE0 | P6EE1 | P6EE2)	! unselect all

	SDA_HIGH		! ep2rom DO is SDA input mode
	ld a, $ZEROBIT
	st a, *CLOCK	! e2prom CK
	st a, *DATA		! e2prom DI
	rts

!
!  Select e2prom A and send command in B. A destroyed.
!
ee_prologue:

	bsr ee_select

	ld a, $ONEBIT
	st a, *DATA		! Startbit
	st a, *CLOCK
	ld a, $ZEROBIT
	st a, *CLOCK

	bsr ee_sendbyte	! Command/address

	rts

ee_select:

	cmp a, $1
	bz 1f
	bnc 2f
	or @PORT6, $ P6EE0
	br 3f
1:
	or @PORT6, $ P6EE1
	br 3f
2:
	or @PORT6, $ P6EE2
3:
	rts

!
!  Send B to selected e2prom. A destroyed.
!
ee_sendbyte:
	ld a, $8
1:
	st b, *DATA			! bit to send in 0x80 already
	or a, $ONEBIT
	st a, *CLOCK
	and a, $~ONEBIT		! Overuse hibit of A
	st a, *CLOCK
	asl b
	adc b, $0
	dec a
	bnz 1b
	rts

!---------------------------------------------------------------------
!
!  What you see is...
!
upd_indicators:

	ld b, @indicators		! Remember previous to check change.

	and @indicators, $~(IND_BUSY | IND_BATT)

	!-----------------------------------------------------------------
	bit @PORT6, $P6BATT1	! First warning when this drops
	bnz 1f
	or @indicators, $IND_BATT
	bit @flags, $LOW_BATT
	bnz 1f
	or @flags, $LOW_BATT
	push b
	jsr pompompom			! Scream once.
	pop b
1:

	!-----------------------------------------------------------------

	bit @PORT6, $ P6TXON
	bnz 9f
1:
	ld a, $ZEROBIT
	bit @signal, $0x10		! 10 to 20 ms of signal
	bz 1f
	ld x, $500
	st x, @rxon_timer		! 5 seconds without powersaving
	or @indicators, $IND_BUSY
	ld a, $ONEBIT
	st a, *RXON
1:
	st a, *AUDIO

	!-----------------------------------------------------------------
9:
	cmp b, @indicators		! Changes ?
	bz 9f
	ld b, @small_update_reqd	! Screw feedback visible ?
	bnz 9f
	jsr update_small_lcd
9:
	rts

!----------------------------------------------------------------------
!
!  Main commutator loop
!
main:

	bit @PORT6, $P6BATT2	! Battery exhausted.
	bnz 1f
	jmp poweroff
1:
	!-----------------------------------------------------------------

	bit @PORT5, $P5PTT1
	bz 9f
		bit @PORT6, $P6MONI
		bz 1f
			jsr repeater_beep
		1:
		bit @txflag, $0xFF
		bnz 3f
			ld a, @digidx
			bz 2f
			jsr do_dtmf_burst		! In case digits visible
			br 3f
		2:
			jsr tx_on
			br 3f
	9:
		ld a, $ZEROBIT
		bit @PORT6, $P6MONI
		bz 1f
			ld x, $500
			st x, @rxon_timer		! 5 seconds active listening.
			ld a, $ONEBIT
			st a, *RXON
			bit @monidown, $ 0xFF
			bnz 1f
			jsr draw_feedback
			ld a, $1
			st a, *small_update_reqd
			ld a, $ONEBIT
		1:
		st a, *LCD_LIGHT
		st a, @monidown

		bit @txflag, $0xFF
		bz 3f
			jsr rx_on
3:

	!-----------------------------------------------------------------

	bit @PORT2, $P2UP
	bnz 1f
		jsr up_button
		br 9f
1:

	bit @PORT2, $P2DOWN
	bnz 1f
		jsr down_button
		br 9f
1:
	ld a, @keyscan_timer
	bnz 1f
		ld a, @key_guard
		bz 2f
		bit @PORT6, $P6MONI
		bz 1f
	2:
		jsr check_keypad
		br 9f
1:
9:
	!-----------------------------------------------------------------

	jsr upd_indicators

	ld a, @ee_update_reqd
	inc a
	bnz 1f
	st a, @ee_update_reqd
	jsr store_state
1:
	ld a, @small_update_reqd
	inc a
	bnz 1f
	st a, @small_update_reqd
	jsr update_small_lcd
1:
	!-----------------------------------------------------------------
	ld a, @scan_mode
	bz 1f
	ld x, @scan_state
	bz 1f
	jmp *x				! do something with scanner
scanner_ret:
	pop x
	st x, @scan_state	! remember place
1:
	ld a, *packet_rdy
	bz 1f
	jsr handle_packet
	clr a
	st a, *packet_rdy
1:
	!-----------------------------------------------------------------
	bit @txflag, $0xFF
	bnz 1f
	wai				! energy star compliance, not when transmitting.
1:
	jmp main

!----------------------------------------------------------------------

append_packet_crc:
	
!
!  crc = crchi ^ crc16_table[crclo ^ c]
!

	ld d, $0xFFFF		! crc kept here

#define ADD_CRC(addr)	\
	xor b, *(addr)		;\
	ld x, $crctbl		;\
	add x, b			;\
	add x, b			;\
	ld b, a				;\
	ld a, x[0]			;\
	xor b, x[1]			;

	ADD_CRC(outpacket + 0)
	ADD_CRC(outpacket + 1)
	ADD_CRC(outpacket + 2)
	ADD_CRC(outpacket + 3)
	ADD_CRC(outpacket + 4)
	ADD_CRC(outpacket + 5)

	cpl a
	st a, *(outpacket + 6)
	cpl b
	st b, *(outpacket + 7)

	rts

check_packet:
	
	ld d, $0xFFFF		! crc kept here

	ADD_CRC(packet + 0)
	ADD_CRC(packet + 1)
	ADD_CRC(packet + 2)
	ADD_CRC(packet + 3)
	ADD_CRC(packet + 4)
	ADD_CRC(packet + 5)

	cpl a
	cmp a, *(packet + 6)
	bnz 1f
	cpl b
	cmp b, *(packet + 7)
	bnz 1f
	ld d, *(packet      + 0)
	st d, *(packet_good + 0)
	ld d, *(packet      + 2)
	st d, *(packet_good + 2)
	ld d, *(packet      + 4)
	st d, *(packet_good + 4)
	ld a, $1
	st a, *packet_rdy
1:
	rts

crctbl:
	.word 0
	.word 4489
	.word 8978
	.word 12955
	.word 17956
	.word 22445
	.word 25910
	.word 29887
	.word 35912
	.word 40385
	.word 44890
	.word 48851
	.word 51820
	.word 56293
	.word 59774
	.word 63735
	.word 4225
	.word 264
	.word 13203
	.word 8730
	.word 22181
	.word 18220
	.word 30135
	.word 25662
	.word 40137
	.word 36160
	.word 49115
	.word 44626
	.word 56045
	.word 52068
	.word 63999
	.word 59510
	.word 8450
	.word 12427
	.word 528
	.word 5017
	.word 26406
	.word 30383
	.word 17460
	.word 21949
	.word 44362
	.word 48323
	.word 36440
	.word 40913
	.word 60270
	.word 64231
	.word 51324
	.word 55797
	.word 12675
	.word 8202
	.word 4753
	.word 792
	.word 30631
	.word 26158
	.word 21685
	.word 17724
	.word 48587
	.word 44098
	.word 40665
	.word 36688
	.word 64495
	.word 60006
	.word 55549
	.word 51572
	.word 16900
	.word 21389
	.word 24854
	.word 28831
	.word 1056
	.word 5545
	.word 10034
	.word 14011
	.word 52812
	.word 57285
	.word 60766
	.word 64727
	.word 34920
	.word 39393
	.word 43898
	.word 47859
	.word 21125
	.word 17164
	.word 29079
	.word 24606
	.word 5281
	.word 1320
	.word 14259
	.word 9786
	.word 57037
	.word 53060
	.word 64991
	.word 60502
	.word 39145
	.word 35168
	.word 48123
	.word 43634
	.word 25350
	.word 29327
	.word 16404
	.word 20893
	.word 9506
	.word 13483
	.word 1584
	.word 6073
	.word 61262
	.word 65223
	.word 52316
	.word 56789
	.word 43370
	.word 47331
	.word 35448
	.word 39921
	.word 29575
	.word 25102
	.word 20629
	.word 16668
	.word 13731
	.word 9258
	.word 5809
	.word 1848
	.word 65487
	.word 60998
	.word 56541
	.word 52564
	.word 47595
	.word 43106
	.word 39673
	.word 35696
	.word 33800
	.word 38273
	.word 42778
	.word 46739
	.word 49708
	.word 54181
	.word 57662
	.word 61623
	.word 2112
	.word 6601
	.word 11090
	.word 15067
	.word 20068
	.word 24557
	.word 28022
	.word 31999
	.word 38025
	.word 34048
	.word 47003
	.word 42514
	.word 53933
	.word 49956
	.word 61887
	.word 57398
	.word 6337
	.word 2376
	.word 15315
	.word 10842
	.word 24293
	.word 20332
	.word 32247
	.word 27774
	.word 42250
	.word 46211
	.word 34328
	.word 38801
	.word 58158
	.word 62119
	.word 49212
	.word 53685
	.word 10562
	.word 14539
	.word 2640
	.word 7129
	.word 28518
	.word 32495
	.word 19572
	.word 24061
	.word 46475
	.word 41986
	.word 38553
	.word 34576
	.word 62383
	.word 57894
	.word 53437
	.word 49460
	.word 14787
	.word 10314
	.word 6865
	.word 2904
	.word 32743
	.word 28270
	.word 23797
	.word 19836
	.word 50700
	.word 55173
	.word 58654
	.word 62615
	.word 32808
	.word 37281
	.word 41786
	.word 45747
	.word 19012
	.word 23501
	.word 26966
	.word 30943
	.word 3168
	.word 7657
	.word 12146
	.word 16123
	.word 54925
	.word 50948
	.word 62879
	.word 58390
	.word 37033
	.word 33056
	.word 46011
	.word 41522
	.word 23237
	.word 19276
	.word 31191
	.word 26718
	.word 7393
	.word 3432
	.word 16371
	.word 11898
	.word 59150
	.word 63111
	.word 50204
	.word 54677
	.word 41258
	.word 45219
	.word 33336
	.word 37809
	.word 27462
	.word 31439
	.word 18516
	.word 23005
	.word 11618
	.word 15595
	.word 3696
	.word 8185
	.word 63375
	.word 58886
	.word 54429
	.word 50452
	.word 45483
	.word 40994
	.word 37561
	.word 33584
	.word 31687
	.word 27214
	.word 22741
	.word 18780
	.word 15843
	.word 11370
	.word 7921
	.word 3960


!----------------------------------------------------------------------
!
leave_memory:
	and @memory, $63			! Leaving 'C'
	or @memory, $128			! and memory
	push x
	ld x, *rptroff_default
	st x, *rptroff
	pop x
	rts

!----------------------------------------------------------------------
!

scan_end:

	bit @scan_mode, $0xFF
	bz 9f
	clr *scan_mode
	jsr vip_recall
	and @indicators, $~IND_SCAN
	jsr update_small_lcd
9:
	rts

scan_start:
	clr *vip_idx

	or @indicators, $IND_SCAN
	jsr update_small_lcd

scan_do_step:

	ld x, $ 1f
	ld b, @scan_mode
	and b, $7
	asl b
	add x, b
	ld x, *x
	jmp *x

1:
	.word scan_next_bad		! 0
	.word scan_next_band	! 1
	.word scan_next_memory	! 2
	.word scan_next_vfos	! 3
	.word scan_next_bad		! 4
	.word scan_next_bad		! 5
	.word scan_next_bad		! 6
	.word scan_next_bad		! 7

check_for_reject:
	cmp x, *reject_0; bz 9f
	cmp x, *reject_1; bz 9f
	cmp x, *reject_2; bz 9f
	cmp x, *reject_3; bz 9f
	cmp x, *reject_4; bz 9f
	cmp x, *reject_5; bz 9f
	cmp x, *reject_6; bz 9f
	cmp x, *reject_7; bz 9f
	cmp x, *reject_8; bz 9f
	cmp x, *reject_9; bz 9f
9:
	rts

scan_next_bad:
	jsr scan_end
	jsr scanner_ret

!----------------------------------------------------------------------

scan_do_wait:				! Common rendezvous after channel selection

	ld x, $8
	st x, @scan_timer

	jsr draw_freq
1:
	jsr scanner_ret			! Come back later

	ld x, @scan_timer		! ... later. 
	bnz 1b

	bit @signal, $0x08		! Should be stable. look into BUSY
	bnz 1f
	jmp scan_do_step		! No signal. Next channel
1:
	ld x, @channel
	jsr save_vip_channel

	ld x, $1500
	st x, @scan_timer

3:
	jsr scanner_ret

	bit @signal, $0x01
	bz 1f					! Signal drop.
	ld x, @scan_timer
	bnz 3b
	jmp scan_do_step		! Wait until signal drops or 15 sec elapses.
1:
	ld x, $100
	st x, @scan_timer
1:
	jsr scanner_ret

	bit @signal, $0x08
	bnz 3b					! Signal again. Restart 15 sec
	ld x, @scan_timer
	bnz 1b

	jmp scan_do_step		! No signal for 1 sec. Next.

!----------------------------------------------------------------------

scan_next_memory:

	ld b, @memory
	ld a, $65
2:
	inc b				! Next memory
	dec a
	bnz 1f
	jmp scan_next_bad	! No available memories ! End.
1:
	jsr get_b_memory
	cmp x, $ MEM_SCANNABLE
	bc 2b				! Empty or skipped
	xch x, d
	and a, $ MEM_CHMSK
	xch x, d
	jsr check_for_reject
	bz 2b				! Rejected.

	jsr set_b_memory

	jmp scan_do_wait

!----------------------------------------------------------------------

scan_next_band:

	jsr leave_memory

	ld x, @channel
4:
	inc x
	inc x
	cmp x, $ f2chan(434975)
	bhi 1f
	cmp x, $ f2chan(434600)
	bhi 2f
	cmp x, $ f2chan(433575)
	bhi 3f
	br 2f
1:
	ld x, $ f2chan(433400)
	br 2f
3:
	ld x, $ f2chan(434600)
2:
	jsr check_for_reject
	bz 4b

	st x, @channel

	jsr wake_upd_synth

	jmp scan_do_wait

!----------------------------------------------------------------------
!
!  First on "VFO", then "C", then "memories", then "VFO" again
!  Between each cycle, sleep.
!

scan_next_vfos:

	ld x, $10
	st x, @scan_timer
1:
	jsr scanner_ret
	ld x, @scan_timer
	bnz 1b

	ld b, @memory
	cmp b, $64
	bnc 1f
	or b, $128			! to "VFO" from memory
	st b, @memory
	ld x, @B_channel
	st x, @channel		! Restore VFO frequency
	jsr wake_upd_synth
	jmp scan_do_wait
1:
	cmp b, $128
	bnc 1f
	jsr set_b_memory	! to "memories" from C
	ld x, @B_channel
	jmp scan_do_wait
1:
	sei
	ld a, $ZEROBIT
	st a, *AUDIO		! and audio.
	st a, *RXON			! shut down rx.
	ld x, $0
	st x, @rxon_timer	!
	ld x, $90
	st x, @rxoff_timer	! powersave for 0.9 seconds.
	cli
1:
	jsr scanner_ret
	ld x, @rxoff_timer
	bnz 1b				! Wait until powersave ends

	ld b, @memory
	and b, $~128		! to C from VFO
	or b, $64
	st b, @memory
	ld x, @C_channel
	st x, @channel		! Set C frequency
	jsr wake_upd_synth
	jmp scan_do_wait

!----------------------------------------------------------------------

save_vip_channel:
	ld b, @memory
	cmp b, $64
	bc 1f
	ld d, @channel
	br 2f
1:
	ld a, $ HI(VIP_IS_MEM)
2:
	st d, *vip_tmp

	ld x, *vip_0
	cmp x, *vip_tmp
	bz 9f
	ld d, *vip_1
	st x, *vip_1
	xch d, x
	cmp x, *vip_tmp
	bz 9f
	ld d, *vip_2
	st x, *vip_2
	xch d, x
	cmp x, *vip_tmp
	bz 9f
	ld d, *vip_3
	st x, *vip_3
	xch d, x
	cmp x, *vip_tmp
	bz 9f
	st x, *vip_4
9:
	ld x, *vip_tmp
	st x, *vip_0
	rts

!----------------------------------------------------------------------

up_button:
	jsr scan_end

	bit @memory, $0xC0
	bnz 1f
	ld a, $64
2:
	ld b, @memory
	inc b				! Up memory
	jsr set_b_memory
	bnz 9f
	dec a
	bnz 2b				! Ignore empty ones
	br 9f
1:
	ld d, @channel		! Up channel
	and b, $~1
	add d, $2
	br 8f

down_button:
	jsr scan_end

	bit @memory, $0xC0
	bnz 1f
	ld a, $64
2:
	ld b, @memory
	dec b				! Down memory
	jsr set_b_memory
	bnz 9f
	dec a
	bnz 2b				! Ignore empty ones
	br 9f
1:
	ld d, @channel		! Down channel
	sub d, $1
	and b, $~1
8:
	st d, @channel

	jsr leave_memory

	jsr wake_upd_synth
9:

	ld a, $100
	st a, @keyscan_timer	! Fingers to keypad takes at least 1 sec...

	ld d, $0
	st d, @digval
	st b, @digidx

	jsr draw_freq

	ld a, $1
	st a, @ee_update_reqd
	st a, @small_update_reqd

	jsr draw_feedback

1:
	bit @PORT2, $P2UP
	bz 1b
	bit @PORT2, $P2DOWN
	bz 1b					! In case contacts still closed.

	rts

!----------------------------------------------------------------------
1:
	rts

handle_packet:

	ld a, *(packet_good + 3)
	lsr a; lsr a; lsr a; lsr a
	cmp a, *(mycall + 0)
	bnz 1b
	ld a, *(packet_good + 3)
	and a, $0xF
	cmp a, *(mycall + 1)
	bnz 1b
	ld a, *(packet_good + 4)
	lsr a; lsr a; lsr a; lsr a
	cmp a, *(mycall + 2)
	bnz 1b
	ld a, *(packet_good + 4)
	and a, $0xF
	cmp a, *(mycall + 3)
	bnz 1b
	ld a, *(packet_good + 5)
	lsr a; lsr a; lsr a; lsr a
	cmp a, *(mycall + 4)
	bnz 1b

	ld x, $dpydigits

	ld b, $ 0xC
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ 0xA
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ LCD_L
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ LCD_L
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ LCD_blank
	jsr draw_lcd_digit; inc x; inc x

	ld b, *(packet_good + 0)
	and b, $ 0xF
	jsr draw_lcd_digit; inc x; inc x
	
	ld b, *(packet_good + 1)
	lsr b; lsr b; lsr b; lsr b
	jsr draw_lcd_digit; inc x; inc x

	ld b, *(packet_good + 1)
	and b, $ 0xF
	jsr draw_lcd_digit; inc x; inc x
	
	ld b, *(packet_good + 2)
	lsr b; lsr b; lsr b; lsr b
	jsr draw_lcd_digit; inc x; inc x

	ld b, *(packet_good + 2)
	and b, $ 0xF
	jsr draw_lcd_digit; inc x; inc x

	jsr dingdong
	jsr update_big_lcd
	rts

draw_packet:

	ld x, $dpydigits
	ld b, $0
1:
	cmp x, $(dpydigits + SIZE(dpydigits))
	bz 9f

	push b
	push x
	ld x, $packet_good
	add x, b
	ld b, *x
	pop x
	push b
	lsr b; lsr b; lsr b; lsr b
	cmp b, $0xF
	bnz 2f
	ld b, $ LCD_blank
2:
	jsr draw_lcd_digit; inc x; inc x
	pop b
	and b, $ 0xF
	cmp b, $0xF
	bnz 2f
	ld b, $ LCD_blank
2:
	jsr draw_lcd_digit; inc x; inc x
	
	pop b
	inc b
	br 1b
9:
	jsr update_big_lcd
	rts

draw_digit_buffer:

	ld x, $dpydigits
	ld b, $0
1:
	cmp x, $(dpydigits + SIZE(dpydigits))
	bz 9f
	cmp b, @digidx
	bz 1f

	push b
	push x
	ld x, $digbuf
	add x, b
	ld b, *x
	pop x
	jsr draw_lcd_digit; inc x; inc x
	pop b
	inc b
	br 1b
1:
	clr x[0]; clr x[1]; inc x; inc x
	cmp x, $(dpydigits + SIZE(dpydigits))
	bnz 1b
9:
	jmp update_big_lcd

draw_freq:

	ld a, @digidx
	bnz draw_digit_buffer

	ld d, @channel
	bit @txflag, $0xFF
	bz 1f
	add d, @rptrfix
1:
	xch d, x
	cmp x, $ NCHANNELS + 1
	bc 1f
	jmp draw_oops
1:
	xch d, x

	ld x, $0000				! binary kHz counter from base up

	lsr d
	xch d, x
	bnc 1f
	add d, $12
1:						! D has base plus possible 12.5, X has full channels

	cmp x, $0
	bz 2f
1:
	add d, $25
	dec x
	bnz 1b
2:						! D has XXXX kHz over base

	ld x, $-1; 1: inc x; sub d, $10000; bnc 1b; add d, $10000; push x
	ld x, $-1; 1: inc x; sub d, $ 1000; bnc 1b; add d, $ 1000; push x
	ld x, $-1; 1: inc x; sub d, $  100; bnc 1b; add d, $  100; push x
	ld a, $-1; 1: inc a; sub b, $   10; bnc 1b; add b, $   10; push a; push b

	ld x, $(dpydigits + SIZE(dpydigits) - 2)

	pop b
	jsr draw_lcd_digit; dec x; dec x;
	pop b
	st b, *feedback_ones
	jsr draw_lcd_digit; dec x; dec x;
	pop b;
	pop b
	st b, *feedback_tens
	jsr draw_lcd_digit; dec x; dec x;
	pop b;
	pop b
	jsr draw_lcd_digit; dec x; dec x;
	pop b;
	pop b;
	add b, $3
	jsr draw_lcd_digit; dec x; dec x;
	ld b, $4
	jsr draw_lcd_digit; dec x; dec x;

	push x
	ld b, $LCD_blank
	ld x, @rptrfix
	bz 1f
	ld b, $LCD_rpos
	cmp x, $ 8000
	bc 1f
	ld b, $LCD_rneg
1:
	pop x

	jsr draw_lcd_digit; dec x; dec x;	! r for -, L for + duplex

	ld b, $LCD_blank
	jsr draw_lcd_digit; dec x; dec x;	! always blank

	ld b, @memory

	cmp b, $64
	bnc 2f
	ld a, $-1
1:
	inc a
	sub b, $10
	bnc 1b
	add b, $10
	cmp a, $0
	bnz 1f
	ld a, $LCD_blank
1:
	push a
	jsr draw_lcd_digit; dec x; dec x;
	pop b
	jsr draw_lcd_digit;

	bit @memflag, $ MEM_SCAN
	bnz 9f
	ld a, *(dpydigits + 5)
	or a, $ 0xFF		! " 7~ r434775"
	st a, *(dpydigits + 5)
	br 9f
2:
	cmp b, $128
	bnc 3f
	clr x[0]; clr x[1]; dec x; dec x
	ld b, $0xC;
	jsr draw_lcd_digit;
	br 9f
3:
	clr x[0]; clr x[1]; dec x; dec x
	clr x[0]; clr x[1]
9:
	jmp update_big_lcd

!----------------------------------------------------------------------
draw_lcd_digit:

	push x				! Save cursor
	xch d, x
	lsr d				! Select which map to use
	lsr d				! for mapping digit to segments.
	xch d, x			! Restore D data

	ld x, $segtbl_even
	bnc 1f
	ld x, $segtbl_odd
1:
	asl b
	add x, b
	ld d, *x
	pop x
	st d, *x

	rts

!----------------------------------------------------------------------
!

tx_on_no_mic:
	jsr tx_on
	and @PORT6, $~P6MIC
	rts

tx_on:
	or @txflag, $0x01
	jsr scan_end
	jsr save_vip_channel
	ld a, $ZEROBIT
	st a, *AUDIO
	st a, *RXON
	jsr tx_synth
	ld d, @channel
	add d, @rptrfix
	xch d, x
	cmp x, $ f2chan(430000)
	bc 1f
	cmp x, $ f2chan(450000)
	bhi 1f
	or @PORT6, $ (P6TXON | P6MIC)
	or @indicators, $ IND_TX
	jsr update_small_lcd
	jsr draw_freq
	rts
1:
	jsr pompompom
	rts

rx_on:
	and @PORT6, $~(P6MIC | P6TXON)
	jsr rx_synth
	ld x, $1000
	st x, @rxon_timer		! 10 seconds without powersaving
	ld a, $ONEBIT
	st a, *RXON
	and @txflag, $0x00
	and @indicators, $~IND_TX
	jsr update_small_lcd
	jsr draw_freq
	rts

!----------------------------------------------------------------------

repeater_beep:
	ld x, $100				! 50 pulses, reload every 1ms as long as btns down
	ld a, $(PROCCLK / 8 / (2 * 1750)) - 1
	br 9f

keyblip:
	ld x, $4				! 2 pulses
	ld a, $(PROCCLK / 8 / (2 * 600)) - 1
	br 9f

keyblop:
	ld x, $8				! 10 pulses
	ld a, $(PROCCLK / 8 / (2 * 800)) - 1
	br 9f

pompompom:
	ld x, $50
	ld a, $(PROCCLK / 8 / (2 * 200)) - 1
	br 9f

dingdong:
	ld a, $ 9
	st a, @dingdongsw
	ld x, $50
	ld a, $(PROCCLK / 8 / (2 * 1400)) - 1
	br 9f

9:
	st a, @TCONR
	or @TCSR3, $T2E			! Start beeper
	st x, @sidetone_timer	! for this many halfpulses
	rts

! Send digits in quick DTMF burst

do_dtmf_burst:

	jsr tx_on_no_mic

	ld b, $0
2:
	ld a, $ DTMF_OFF
	jsr iic_dtmf

	ld x, $5			! Silence delay 51 ms
	st x, @spack_timer
1:
	ld x, @spack_timer
	bnz 1b

	cmp b, @digidx
	bz 2f

	push b
	ld x, $digbuf
	add x, b
	ld b, *x
	ld x, $dtmftbl
	add x, b
	ld a, *x
	jsr iic_dtmf

	ld x, $5			! Tone delay 51 ms
	st x, @spack_timer
1:
	ld x, @spack_timer
	bnz 1b

	pop b
	inc b
	br 2b
2:

	! Tick locally, but keep tick out of air...
	jsr keyblip
1:
	ld x, @sidetone_timer
	bnz 1b

	or @PORT6, $ P6MIC		! Then mic for possible voice continue
	rts

!----------------------------------------------------------------------

draw_feedback:

	ld b, @memory
	cmp b, $64
	bnc 2f				! skip if "vfo"
	ld a, $-1
1:
	inc a
	sub b, $10
	bnc 1b
	add b, $10
	st b, *feedback_ones
	st a, *feedback_tens
	cmp a, $0
	bnz 2f
	ld a, $ SMALL_blank
	st a, *feedback_tens
2:

	ld b, *feedback_tens
	asl b					! each font record is
	asl b					! 4 bytes
	ld x, $segtbl_small
	add x, b
	push x
	ld b, *feedback_ones
	asl b
	asl b
	ld x, $segtbl_small
	add x, b
	ld d, x[0]
	pop x
	or b, x[2]
	or a, x[3]		! XXX every other word in table is byterevved

	push a
	push b

	ld a, $ZEROBIT
	st a, *DLEN
	st a, *DATA

	ld a, $ONEBIT
	st a, *DLEN

	jsr zerobit		! leading zerobit

	ld b, $0		! @indicators
	ld x, $4
	jsr sendit		! BUSY BATT TX SCAN

	pop b
	ld x, $8
	jsr sendit		! First group of twodigit channel

	ld d, $0xFF
	ld x, $8
	jsr sendit		! Padding

	jsr onebit		! This was group 1

	ld a, $ZEROBIT
	st a, *DLEN
	st a, *DATA

	jsr clockit		! load pulse for group 1

	ld a, $ONEBIT
	st a, *DLEN

	jsr zerobit		! leading zerobit

	ld b, $0xF
	ld x, $4
	jsr sendit		! Padding

	pop b
	ld x, $8
	jsr sendit		! Second group of twodigit channel

	ld d, $0xFF
	ld x, $8
	jsr sendit		! Padding

	jsr zerobit		! This was group 0

	ld a, $ZEROBIT
	st a, *DLEN
	st a, *DATA

	jsr clockit		! load pulse for group 0

	rts

draw_version:

	ld x, $dpydigits

	ld b, $ 5
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ 0
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ 0xF
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ LCD_t
	jsr draw_lcd_digit; inc x; inc x
	ld b, $LCD_blank
	jsr draw_lcd_digit; inc x; inc x
	ld b, $LCD_blank
	jsr draw_lcd_digit; inc x; inc x

	ld b, $ LCD_blank
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ LCD_blank
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ VERSMAJ
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ VERSMIN
	jsr draw_lcd_digit; inc x; inc x

	jsr update_big_lcd
	rts

draw_oops:

	ld x, $dpydigits

	ld b, $LCD_blank
	jsr draw_lcd_digit; inc x; inc x
	ld b, $LCD_blank
	jsr draw_lcd_digit; inc x; inc x
	ld b, $LCD_blank
	jsr draw_lcd_digit; inc x; inc x
	ld b, $LCD_blank
	jsr draw_lcd_digit; inc x; inc x
	ld b, $LCD_blank
	jsr draw_lcd_digit; inc x; inc x
	ld b, $LCD_blank
	jsr draw_lcd_digit; inc x; inc x

	ld b, $ 0
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ 0
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ LCD_P
	jsr draw_lcd_digit; inc x; inc x
	ld b, $ 5
	jsr draw_lcd_digit; inc x; inc x

	jsr update_big_lcd
	rts

!----------------------------------------------------------------------
!
!  Rewrite duplex offset of current memory
!  to the current default offset
!
rewrite_curmem_offset:
	ld b, @memory
	asl b
	ld x, $ offsets
	add x, b
	ld d, @rptrfix
	st d, *x
	xch d, x
	ld b, $ EE_OFFSET_BLOCK
	or b, @memory
	jsr memory_write
	ld b, @memory
	jsr set_b_memory
	rts

clearbuf:
	clr *(digval + 0)
	clr *(digval + 1)
	clr *digidx
	rts

!----------------------------------------------------------------------
!
!  Hello Fylde ppl !
!
	.ascii "\nIndeed, rather nosy, I would say, yes.\n"
	.ascii "\n6303 sure beats Cosmac.\n"

textsize = . - version

!----------------------------------------------------------------------
!
!  Vectors
!
	.org 0xFFE0
	.byte 0

	.org 0xFFE8

.word _unk   ! FFE8
.word _irq2  ! FFEA /IRQ2                                 
.word _cmi   ! FFEC CMI   Timer 2 Counter Match           for txbeeps
.word _trap  ! FFEE TRAP
.word _sio   ! FFF0 SIO   RDRF + ORFE + TDRE + PER
.word _toi   ! FFF2 TOI   Timer 1 Overflow
.word _oci   ! FFF4 OCI   Timer 1 Output Compare 1, 2     system timer tick
.word _ici   ! FFF6 ICI   Timer 1 Input Capture           rxsync from modem
.word _irq1  ! FFF8 /IRQ1
.word _swi   ! FFFA SWI   Software Interrupt
.word _nmi   ! FFFC /NMI
.word _start ! FFFE /RES  RESET

	ASSERT(. == 0)	! overflow of 0x10000

